VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CCrypto"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'****************************************************
'* CCrypto.cls                                      *
'* advanced Xor encryption class                    *
'* provides a nearly 100% secure encryption that is *
'* uncrackable by modern computers due to the use   *
'* of a OneTimePad and a high precision pseudo      *
'* random creator                                   *
'* Based on Advanced Vigenre by Konrad Rudolph     *
'* Programmed: Udo Schmidt                          *
'* Last Change: 16-Feb-2004                         *
'* Version: 1.0.0                                   *
'****************************************************


Option Base 0
Option Explicit
Option Compare Text

Private Const def_flg                   As Long = 72
Private Const def_len                   As Long = 73
Private Const PAGE_EXECUTE_READWRITE    As Long = &H40&
Private Const MEM_COMMIT                As Long = &H1000&
Private Const MEM_RELEASE               As Long = &H8000&

Dim asm()       As Long
Dim DEF()       As Long
Dim hMem        As Long
Dim lMemLength  As Long

Private Declare Function API_VirtualAlloc _
    Lib "kernel32.dll" Alias "VirtualAlloc" _
   (ByRef lpAddress As Any, _
    ByVal dwSize As Long, _
    ByVal flAllocationType As Long, _
    ByVal flProtect As Long) As Long
    
Private Declare Function API_VirtualFree _
    Lib "kernel32.dll" Alias "VirtualFree" _
   (ByRef lpAddress As Any, _
    ByVal dwSize As Long, _
    ByVal dwFreeType As Long) As Long

Private Declare Sub API_CopyByRef _
    Lib "kernel32" Alias "RtlMoveMemory" _
   (ByRef hpvDest As Any, _
    ByRef hpvSource As Any, _
    ByVal cbCopy As Long)

Private Declare Function ASM_Hash _
    Lib "user32" Alias "CallWindowProcA" _
   (ByRef asm As Long, _
    ByVal src As Long, _
    ByVal Ref As Long, _
    ByRef tgt As Long, _
    ByRef DEF As Long) As Long

Private Sub Class_Initialize()
    ReDim asm(124)
    ReDim DEF(73)

    ' program code
    asm(0) = &HEC8B5590:  asm(1) = &H8B575653:  asm(2) = &H968B1475
    asm(3) = &H120:       asm(4) = &H124868B:   asm(5) = &H50520000
    asm(6) = &H1A8EC81:   asm(7) = &HC2F60000:  asm(8) = &HA81D7401
    asm(9) = &HBC850F3F:  asm(10) = &HC1000001: asm(11) = &H840F06E8
    asm(12) = &H1B3:      asm(13) = &HC7E84589: asm(14) = &HFFFFE445
    asm(15) = &H52EBFFFF: asm(16) = &H8A09C083: asm(17) = &H6E8C1C8
    asm(18) = &H743FC1F6: asm(19) = &H45894001: asm(20) = &H24BC8DE8
    asm(21) = &H120:      asm(22) = &HB9EC758B: asm(23) = &H3F
    asm(24) = &HF133CE23: asm(25) = &H3E47589:  asm(26) = &H37BB0875
    asm(27) = &H2B000000: asm(28) = &H830373D9: asm(29) = &HA4F340C3
    asm(30) = &H478007C6: asm(31) = &HCB8AC18A: asm(32) = &H458BAAF3
    asm(33) = &HF708B1EC: asm(34) = &HFCA0FE1:  asm(35) = &H891789C8
    asm(36) = &H7D8B0447: asm(37) = &H14758B10: asm(38) = &H100C681
    asm(39) = &H8B90000:  asm(40) = &HF3000000: asm(41) = &H8558BA5
    asm(42) = &H40E46D83: asm(43) = &H948D0773: asm(44) = &H12024
    asm(45) = &H8BFC8B00: asm(46) = &H8B11075:  asm(47) = &HDF8BA5F3
    asm(48) = &HFB1F28B:  asm(49) = &H1F045F7:  asm(50) = &H75000000
    asm(51) = &H8E048B0B: asm(52) = &H489C80F:  asm(53) = &HF579498F
    asm(54) = &H8BA5F341: asm(55) = &HD23352F4: asm(56) = &H7240FA83
    asm(57) = &HF8438B32: asm(58) = &HF88BC88B: asm(59) = &HC111C8C1
    asm(60) = &HEFC113C9: asm(61) = &H33C1330A: asm(62) = &H8B0389C7
    asm(63) = &HC88BC443: asm(64) = &HC8C1F88B: asm(65) = &H12C9C107
    asm(66) = &H3303EFC1: asm(67) = &H3C733C1:  asm(68) = &H4303E443
    asm(69) = &H8B0301C0: asm(70) = &HF88B1046: asm(71) = &HF7144623
    asm(72) = &H187E23D7: asm(73) = &H468BF833: asm(74) = &HC1C88B10
    asm(75) = &HC9C106C8: asm(76) = &HC1C1330B: asm(77) = &HC1330EC9
    asm(78) = &H7D8BC703: asm(79) = &H3A040314: asm(80) = &H31C4603
    asm(81) = &H68B5003:  asm(82) = &H4623F88B: asm(83) = &H87E2304
    asm(84) = &H7E8BC733: asm(85) = &H87E2304:  asm(86) = &H68BF833
    asm(87) = &HC8C1C88B: asm(88) = &HDC9C102:  asm(89) = &HC9C1C133
    asm(90) = &H3C13309:  asm(91) = &H7E8D50C7: asm(92) = &H18C6831C
    asm(93) = &H7B9:      asm(94) = &HA5F3FD00: asm(95) = &H8FF78BFC
    asm(96) = &H6015806:  asm(97) = &H83104601: asm(98) = &HC28004C3
    asm(99) = &H4D830F04: asm(100) = &H8BFFFFFF: asm(101) = &H7B1107D
    asm(102) = &H18E048B: asm(103) = &H79498F04: asm(104) = &H8B5A41F7
    asm(105) = &HEB830C7D: asm(106) = &HF70FB140: asm(107) = &H1F045
    asm(108) = &H1C740000: asm(109) = &H318B048B: asm(110) = &H4318F04
    asm(111) = &HF479498A: asm(112) = &HC458341: asm(113) = &HE84DFF40
    asm(114) = &HFEE7850F: asm(115) = &H16EBFFFF: asm(116) = &H318B048B
    asm(117) = &H79498F04: asm(118) = &HC28341F7: asm(119) = &HE84DFF40
    asm(120) = &HFEC2850F: asm(121) = &H8DF9FFFF: asm(122) = &HC01BF465
    asm(123) = &H5D5B5E5F: asm(124) = &H10C2
    
    'NX Patch, eingefgt von Kai am 23.01.2005
    lMemLength = (UBound(asm) + 1) * 4
    'Allocieren von ausfhrbarem Speicher
    hMem = API_VirtualAlloc(ByVal 0, lMemLength, MEM_COMMIT, PAGE_EXECUTE_READWRITE)
    If hMem Then
        'ASM Routine rberkopieren
        Call CopyMem(ByVal hMem, asm(0), (UBound(asm) + 1) * 4)
        'Temporres ASM wieder lschen
        Erase asm
    End If
    
    ' dwords for manipulation loop (K)
    DEF(0) = &H428A2F98:  DEF(1) = &H71374491:  DEF(2) = &HB5C0FBCF
    DEF(3) = &HE9B5DBA5:  DEF(4) = &H3956C25B:  DEF(5) = &H59F111F1
    DEF(6) = &H923F82A4:  DEF(7) = &HAB1C5ED5:  DEF(8) = &HD807AA98
    DEF(9) = &H12835B01:  DEF(10) = &H243185BE: DEF(11) = &H550C7DC3
    DEF(12) = &H72BE5D74: DEF(13) = &H80DEB1FE: DEF(14) = &H9BDC06A7
    DEF(15) = &HC19BF174: DEF(16) = &HE49B69C1: DEF(17) = &HEFBE4786
    DEF(18) = &HFC19DC6:  DEF(19) = &H240CA1CC: DEF(20) = &H2DE92C6F
    DEF(21) = &H4A7484AA: DEF(22) = &H5CB0A9DC: DEF(23) = &H76F988DA
    DEF(24) = &H983E5152: DEF(25) = &HA831C66D: DEF(26) = &HB00327C8
    DEF(27) = &HBF597FC7: DEF(28) = &HC6E00BF3: DEF(29) = &HD5A79147
    DEF(30) = &H6CA6351:  DEF(31) = &H14292967: DEF(32) = &H27B70A85
    DEF(33) = &H2E1B2138: DEF(34) = &H4D2C6DFC: DEF(35) = &H53380D13
    DEF(36) = &H650A7354: DEF(37) = &H766A0ABB: DEF(38) = &H81C2C92E
    DEF(39) = &H92722C85: DEF(40) = &HA2BFE8A1: DEF(41) = &HA81A664B
    DEF(42) = &HC24B8B70: DEF(43) = &HC76C51A3: DEF(44) = &HD192E819
    DEF(45) = &HD6990624: DEF(46) = &HF40E3585: DEF(47) = &H106AA070
    DEF(48) = &H19A4C116: DEF(49) = &H1E376C08: DEF(50) = &H2748774C
    DEF(51) = &H34B0BCB5: DEF(52) = &H391C0CB3: DEF(53) = &H4ED8AA4A
    DEF(54) = &H5B9CCA4F: DEF(55) = &H682E6FF3: DEF(56) = &H748F82EE
    DEF(57) = &H78A5636F: DEF(58) = &H84C87814: DEF(59) = &H8CC70208
    DEF(60) = &H90BEFFFA: DEF(61) = &HA4506CEB: DEF(62) = &HBEF9A3F7
    DEF(63) = &HC67178F2

    ' Initial hash values
    DEF(64) = &H6A09E667: DEF(65) = &HBB67AE85: DEF(66) = &H3C6EF372
    DEF(67) = &HA54FF53A: DEF(68) = &H510E527F: DEF(69) = &H9B05688C
    DEF(70) = &H1F83D9AB: DEF(71) = &H5BE0CD19

    ' Parameters
    DEF(72) = 0     ' flags
    DEF(73) = 0     ' message length
End Sub

Private Sub Class_Terminate()
'NX Patch, eingefgt von Kai am 23.01.2005
If hMem Then
    'Speicher freigeben
    Call API_VirtualFree(ByVal hMem, lMemLength, MEM_RELEASE)
    hMem = 0
End If
End Sub

' Crypt     Encryption/Decryption
'
' CALL:     Crypt(src, @tgt, pwd, cmd, [F1:AddSHA], [F2:AddTime], [F3:AddText])
'
' IN:       bar:src Sourcedata
'           bar:tgt Targetdata
'           chr:pwd Password
'           bol:cmd .F.: Encrypt
'                   .T.: Decrypt
'           lng:F1  SHA-DWords to be appended (0 to 8)
'           bol:F2  Timestamp to be used?
'           chr:F3  Identifier-string to be appended
'
' OUT:      bol     success
'
Public Function Crypt( _
    src() As Byte, _
    tgt() As Byte, _
    pwd As String, _
    cmd As Boolean, _
    Optional AddSHA As Long = 8, _
    Optional AddTime As Boolean = True, _
    Optional AddText As String = "") As Boolean
    
    Static svd  As Long         ' stored timestamp
    
    Dim txt     As String       ' temp
    Dim bar()   As Byte         ' temp
    Dim sha(8)  As Long         ' hash (+Timestamp)
    Dim tmp(8)  As Long         ' password validation
    Dim Ref(63) As Byte         ' xor message...
    Dim flg     As Boolean      ' password okay?
    Dim UBsrc   As Long         ' UBound(src)+1
    Dim UBtgt   As Long         ' UBound(tgt)+1
    Dim TxLen   As Long         ' Len(AddText)
    Dim ToAdd   As Long         ' onDecrypt: decrease,
                                ' onEncrypt: increase msglen
    
    If x_arrDIM(src) <> 1 Then
        ' invalid no of dimensions
        
    Else
        ' initialize values, create hash(pwd)
        UBsrc = UBound(src) + 1
        x_Hash StrConv(pwd, vbFromUnicode), Ref, sha, False
        
        ' calculate number of additional bytes
        ' (info to be appended/deleted on encryption/decryption)
        If AddSHA Then AddSHA = ((AddSHA - 1) And 7) + 1
        TxLen = Len(AddText)
        ToAdd = AddSHA * 4 _
              + (AddTime And 4) _
              + TxLen
              
        UBtgt = UBsrc + IIf(cmd, -ToAdd, ToAdd)
        
           ' on encrypt: get timestamp, if required
        If cmd = False Then
            If AddTime Then
                ' ensure to get an unique value
                sha(AddSHA) = DateDiff("s", DateSerial(1970, 1, 1), Now)
                If sha(AddSHA) <= svd Then sha(AddSHA) = svd + 1
                svd = sha(AddSHA)
            End If
            
           ' on decrypt: get info from file, check password
        ElseIf UBsrc > ToAdd Then
            flg = True  ' assume no password-check required
            
               ' if available, copy sha and timestamp from src
            If ToAdd > TxLen Then
                API_CopyByRef tmp(0), src(UBsrc - ToAdd), ToAdd - TxLen
                If AddTime Then sha(AddSHA) = tmp(AddSHA)
                
                ' check password, if sha was added
                If AddSHA Then flg = lngCMP(sha(0), tmp(0), AddSHA - 1)
            End If
        End If
        
        If cmd Imp flg Then
            ' create hash(hash+timestamp+pwd)
            txt = LNG2CHR(sha(0), 8)
            x_Hash StrConv(txt & pwd, vbFromUnicode), Ref, tmp, False
        
            ' En/Decrypt message
            ReDim tgt(((UBtgt + 63) And -64&) - 1)
            API_CopyByRef tgt(0), src(0), UBsrc - IIf(cmd, ToAdd, 0)
            x_Hash Ref, tgt, tmp, True
        
            ' onEncode: append admin info
            If cmd = False And ToAdd > 0 Then
                txt = Left$(txt, AddSHA * 4 + (AddTime And 4)) & AddText
                bar = StrConv(txt, vbFromUnicode)
                API_CopyByRef ByVal VarPtr(tgt(0)) + UBsrc, bar(0), ToAdd
            End If
            
            ' adjust length
            ReDim Preserve tgt(UBtgt - 1)
            Crypt = True
        End If
    End If
End Function

Public Function Hash(src() As Byte) As Long()
    Dim tgt(7)  As Long
    Dim Ref(63) As Byte
    
    If x_Hash(src, Ref, tgt, False) Then
        Hash = tgt
    End If
End Function

'FIXIT: 'arr' mit einem Datentyp mit frher Bindung deklarieren                            FixIT90210ae-R1672-R1B8ZE
Private Function x_arrDIM(arr) As Long
    Dim n1 As Long
    Dim n2 As Long
    
    If IsArray(arr) Then
        API_CopyByRef n1, ByVal VarPtr(arr), 2
        API_CopyByRef n2, ByVal VarPtr(arr) + 8, 4
        If n1 And &H4000 Then API_CopyByRef n2, ByVal n2, 4
        If n2 Then API_CopyByRef n1, ByVal n2, 2
        
        If n2 Then x_arrDIM = n1
    End If
End Function

Private Function x_Hash( _
    src() As Byte, _
    Ref() As Byte, _
    sha() As Long, _
    flg As Boolean) As Boolean
    
    DEF(def_flg) = (flg And 1)
    DEF(def_len) = IIf(flg, UBound(Ref), UBound(src)) + 1
    
    'x_Hash = ASM_Hash(asm(0), _
                      VarPtr(src(0)), _
                      VarPtr(Ref(0)), _
                      sha(0), _
                      DEF(0))
    x_Hash = ASM_Hash(ByVal hMem, _
                      VarPtr(src(0)), _
                      VarPtr(Ref(0)), _
                      sha(0), _
                      DEF(0))
End Function

Public Function GetCryptedFile( _
    ByRef FileName As String, _
    ByRef RemoteIP As String, _
    ByRef ChatNick As String, _
    ByRef tgt() As Byte _
) As Boolean

    Dim ff      As Long
    Dim src()   As Byte
    Dim Key     As String

    Key = Keys.FindKey(RemoteIP, ChatNick)

    If Key = "" Then
        'Oops, this should _never_ happen
        ff = FreeFile

        Open FileName For Binary As #ff
            ReDim tgt(LOF(ff) + 36)
            Get #ff, , tgt()
        Close #ff

    Else

        ff = FreeFile

        Open FileName For Binary As #ff
            ReDim src(LOF(ff) - 1)
            Get #ff, , src()
        Close #ff

        Call Crypt(src(), tgt(), Key, False, , , Chr$(1))
        GetCryptedFile = True
    End If
End Function

Public Function SaveCryptedFile( _
    ByRef FileName As String, _
    ByRef RemoteIP As String, _
    ByRef ChatNick As String, _
    ByRef src() As Byte _
) As Boolean

    Dim ff      As Long
    Dim Key     As String
    Dim tgt()   As Byte

    If src(UBound(src())) = 0 Then
        'uncrypted
        ReDim Preserve src(UBound(src()) - 37)
        ff = FreeFile
        Open FileName For Binary As #ff
            Put #ff, , src()
        Close #ff
    Else
        'crypted
        Key = Keys.FindKey(RemoteIP, ChatNick)
        If Key = "" Then _
            Exit Function

        Call Crypt(src(), tgt(), Key, True, , , Chr$(1))

        ff = FreeFile
        Open FileName For Binary As #ff
            Put #ff, , tgt()
        Close #ff
    End If

    SaveCryptedFile = True
End Function



