VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Begin VB.Form dlgMessageHistory 
   Caption         =   "Chatverlauf"
   ClientHeight    =   6030
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   10095
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "dlgMessageHistory.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   6030
   ScaleWidth      =   10095
   StartUpPosition =   3  'Windows-Standard
   Begin projIM.CommonDialog cdlSelectFile 
      Left            =   5760
      Top             =   1560
      _ExtentX        =   873
      _ExtentY        =   873
   End
   Begin RichTextLib.RichTextBox rtbHistory 
      Height          =   2295
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   3855
      _ExtentX        =   6800
      _ExtentY        =   4048
      _Version        =   393217
      BorderStyle     =   0
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      AutoVerbMenu    =   -1  'True
      TextRTF         =   $"dlgMessageHistory.frx":0CCA
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin MSComctlLib.Toolbar tlbHistory 
      Align           =   1  'Oben ausrichten
      Height          =   360
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   10095
      _ExtentX        =   17806
      _ExtentY        =   635
      ButtonWidth     =   1958
      ButtonHeight    =   582
      AllowCustomize  =   0   'False
      Appearance      =   1
      Style           =   1
      TextAlignment   =   1
      _Version        =   393216
      BeginProperty Buttons {66833FE8-8583-11D1-B16A-00C0F0283628} 
         NumButtons      =   2
         BeginProperty Button1 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Caption         =   "Speichern"
            Key             =   "SaveHistory"
            Object.ToolTipText     =   "Chatverlauf speichern"
         EndProperty
         BeginProperty Button2 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Caption         =   "Lschen"
            Key             =   "DeleteHistory"
            Object.ToolTipText     =   "Chatverlauf lschen"
         EndProperty
      EndProperty
   End
   Begin MSComctlLib.ImageList imlToolbar 
      Left            =   6480
      Top             =   840
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483633
      ImageWidth      =   16
      ImageHeight     =   16
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   3
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "dlgMessageHistory.frx":0D45
            Key             =   "Save"
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "dlgMessageHistory.frx":1099
            Key             =   "Delete"
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "dlgMessageHistory.frx":13ED
            Key             =   "Search"
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "dlgMessageHistory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************************************
'*
'* written by Bjrn Tschrtner (2004)
'*
'***********************************************************************************
Option Explicit

Private Const defTitle As String = "Chatverlauf"

Private staHistoryInfo As New clsStatusBar

Dim m_ChatNick As String
Dim m_HistoryFile As String

Private Sub Form_Activate()
Call SetWindowLong(Me.hwnd, GWL_HWNDPARENT, 0)
End Sub

Private Sub Form_Load()

   staHistoryInfo.Create Me.hwnd
   staHistoryInfo.PanelText(1) = "keine Nachrichten"
   Call InitToolBar
      
End Sub

Public Sub ShowMessageHistory(NickName As String)
   On Local Error GoTo ErrorHandler
   Dim FileName As String
   Dim filNo As Integer
   Dim FileContent As String
   
   Me.Caption = NickName & " - " & defTitle
   m_ChatNick = NickName
   
   FileName = dirMessageHistory & dlgMain.ClientManagement.GetDirName(NickName) & ".txt"
   m_HistoryFile = FileName
   filNo = FreeFile

   rtbHistory.Text = ""
   staHistoryInfo.PanelText(1) = "keine Nachrichten"

   If Not FileExists(FileName) Then Exit Sub

   'read hisory data'
   Open FileName For Binary Access Read As filNo
      FileContent = Space$(LOF(filNo))
      Get #filNo, , FileContent
   Close #filNo

   'show data'
   'Call HighlightHistory(FileContent)
   Me.MousePointer = vbHourglass
   Call Me.Show
   Call HighlightInit
   rtbHistory.TextRTF = RtfHighlight(FileContent)
   Me.MousePointer = vbDefault

   Exit Sub

ErrorHandler:
   On Local Error Resume Next
   MsgBox "Fehler beim Laden des Chat-Verlaufes.", vbOKOnly + vbCritical, "Fehler"
   Close #filNo

End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Set staHistoryInfo = Nothing
End Sub

Private Sub Form_Resize()
   On Local Error Resume Next

   rtbHistory.Width = Me.ScaleWidth
   rtbHistory.Height = Me.ScaleHeight - rtbHistory.Top - staHistoryInfo.Height
   staHistoryInfo.Resize Me.hwnd

End Sub

Private Sub InitToolBar()
   Set tlbHistory.ImageList = imlToolbar
   tlbHistory.Buttons("SaveHistory").Image = "Save"
   tlbHistory.Buttons("DeleteHistory").Image = "Delete"
'   tlbHistory.Buttons("Search").Image = "Search"

End Sub

Private Sub tlbHistory_ButtonClick(ByVal Button As MSComctlLib.Button)
   On Local Error Resume Next
   
   Select Case Button.Key
   
      Case "SaveHistory"
         'save history'
         Call ExportHistoryHTML
         
      Case "DeleteHistory"
         'delete history'
         If MsgBox("Mchten Sie den Chatverlauf von ''" & m_ChatNick & "'' wirklich lschen?", vbQuestion + vbYesNo, "Chatverlauf lschen") = vbNo Then Exit Sub
         If FileExists(m_HistoryFile) Then
            Kill m_HistoryFile
         End If
         Call ShowMessageHistory(m_ChatNick)
      
   End Select

End Sub

Private Sub HighlightHistory(Data As String)
   Dim posDate As Long, posTime As Long, posMessage As Long, posFrom As Long, endMessage As Long
   Dim strDate As String, strTime As String, strFrom As String, strMessage As String
   Dim I As Long
   Dim lenText As Long
   Dim cntMessage As Long
   
   Dim oldDate As String
   
   rtbHistory.Visible = False
   
   rtbHistory.Text = ""
   cntMessage = 0
   lenText = Len(Data)
   
   For I = lenText To 1 Step -1
      posDate = InStrRev(Data, vbCrLf, I - 1)
      If posDate = 0 Then
         posDate = 1
      Else
         posDate = posDate + 2
      End If
      
      posTime = InStr(posDate + 1, Data, " ") + 1
      posFrom = InStr(posTime + 1, Data, " ") + 1
      posMessage = InStr(posFrom + 1, Data, vbTab & vbTab) + 1
      endMessage = InStr(posMessage, Data, vbCrLf) + 1

      strDate = Mid$(Data, posDate, posTime - posDate - 1)
      strTime = Mid$(Data, posTime, posFrom - posTime - 1)
      strFrom = Mid$(Data, posFrom, posMessage - posFrom - 1)
      strMessage = Mid$(Data, posMessage + 1, endMessage - posMessage - 2)

      strMessage = Replace(strMessage, "\n", vbCrLf)

      cntMessage = cntMessage + 1

      'add entry to textbox'
      If strDate <> oldDate Then
         oldDate = strDate
         If rtbHistory.Text <> "" Then strDate = vbCrLf & strDate
         'every day a new date'
         rtbHistory.SelStart = Len(rtbHistory.Text): rtbHistory.SelLength = 0
         rtbHistory.SelBold = True
         rtbHistory.SelColor = colDate
         rtbHistory.SelIndent = 0
         rtbHistory.SelText = strDate & vbCrLf
      End If
      
      rtbHistory.SelIndent = 200
            
      'time and name'
      If strFrom = "Local" Then
         rtbHistory.SelStart = Len(rtbHistory.Text): rtbHistory.SelLength = 0
         rtbHistory.SelBold = True
         rtbHistory.SelColor = colOwnUsername
         If modClient.LocalUser.cpUsername <> "" Then
            rtbHistory.SelText = strTime & ", " & modClient.LocalUser.cpUsername & ": "
         Else
            rtbHistory.SelText = strTime & ", " & "Benutzer" & ": "
         End If
      ElseIf strFrom = "System" Then
         rtbHistory.SelStart = Len(rtbHistory.Text): rtbHistory.SelLength = 0
         rtbHistory.SelBold = True
         rtbHistory.SelColor = colSystemMessage
         rtbHistory.SelText = strTime & ": " & strMessage & vbCrLf
      Else
         rtbHistory.SelStart = Len(rtbHistory.Text): rtbHistory.SelLength = 0
         rtbHistory.SelBold = True
         rtbHistory.SelColor = colUsername
         rtbHistory.SelText = strTime & ", " & strFrom & ": "
      End If
      
      If strFrom <> "System" Then
         'message'
         rtbHistory.SelStart = Len(rtbHistory.Text): rtbHistory.SelLength = 0
         rtbHistory.SelBold = False
         rtbHistory.SelColor = colChatMessage
         rtbHistory.SelText = strMessage & vbCrLf
      End If
         
      If cntMessage >= MaxHistoryLength Then Exit For
      I = posDate

   Next I

   rtbHistory.SelStart = 0: rtbHistory.SelLength = 0

   'set state bar text'
   If cntMessage <= 0 Then
      staHistoryInfo.PanelText(1) = "keine Nachrichten"
   ElseIf cntMessage = 1 Then
      staHistoryInfo.PanelText(1) = "eine Nachricht"
   Else
      staHistoryInfo.PanelText(1) = CStr(cntMessage) & " Nachrichten"
   End If

    rtbHistory.Visible = True

End Sub

Private Sub ExportHistoryHTML()
   Dim filNo As Integer
   Dim Data As String
   Dim dstFile As String
   Dim HTMLCode As String
   Dim CSSCode As String
   
   Dim posDate As Long, posTime As Long, posMessage As Long, posFrom As Long, endMessage As Long
   Dim strDate As String, strTime As String, strFrom As String, strMessage As String
   Dim I As Long
   Dim lenText As Long
   Dim cntMessage As Long
   Dim oldDate As String
   
   If Not FileExists(m_HistoryFile) Then
      MsgBox "Fr ''" & m_ChatNick & "'' existiert kein Chatverlauf.", vbExclamation + vbOKOnly, "Chatverlauf speichern"
      Exit Sub
   End If

   'select destination file'
   With cdlSelectFile
      .CancelError = True
      .FileName = ""
      .Filter = "Hypertext-Dokument (*.htm)|*.htm"
      .DialogTitle = "Chatverlauf speichern"
      .ShowSave
      dstFile = .FileName
   End With

   If FileExists(dstFile) Then
      If MsgBox("Die Datei existiert bereits. Mchten Sie diese Datei berschreiben?", vbYesNo + vbExclamation, "Chatverlauf speichern") = vbNo Then Exit Sub
   End If

   'read hisory data'
   filNo = FreeFile
   Open m_HistoryFile For Binary Access Read As filNo
      Data = Space$(LOF(filNo))
      Get #filNo, , Data
   Close #filNo

   'open destination file'
   filNo = FreeFile
   Open dstFile For Output As #filNo
   
   'html header'
   CSSCode = "body {font-family:arial;font-size:12px}" & vbCrLf & _
         "font {margin-left:15px}" & vbCrLf & _
         "font.NoIndent {margin-left:0px}" & vbCrLf

   HTMLCode = "<html><head><title>ActiveVB Messenger Chatverlauf von ''" & m_ChatNick & "''</title>" & vbCrLf & _
         "<style type=" & Chr$(34) & "text/css" & Chr$(34) & "> <!--" & vbCrLf & _
         CSSCode & _
         "--> </style>" & vbCrLf & _
         "</head><body bgcolor=" & Chr$(34) & "#FFFFFF" & Chr$(34) & ">"
         
   Print #filNo, HTMLCode

   'head info'
   HTMLCode = "<font class=" & Chr$(34) & "NoIndent" & Chr$(34) & " size=" & Chr$(34) & "+1" & Chr$(34) & " color=" & Chr$(34) & GetHTMLColor(colSystemMessage) & Chr$(34) & "><b>ActiveVB Messenger Chatverlauf von ''" & m_ChatNick & "''</b></font><br><br>"
   Print #filNo, HTMLCode

   cntMessage = 0
   lenText = Len(Data)

   'save history'
   For I = lenText To 1 Step -1
      posDate = InStrRev(Data, vbCrLf, I - 1)
      If posDate = 0 Then
         posDate = 1
      Else
         posDate = posDate + 2
      End If
      
      posTime = InStr(posDate + 1, Data, " ") + 1
      posFrom = InStr(posTime + 1, Data, " ") + 1
      posMessage = InStr(posFrom + 1, Data, vbTab & vbTab) + 1
      endMessage = InStr(posMessage, Data, vbCrLf) + 1

      strDate = Mid$(Data, posDate, posTime - posDate - 1)
      strTime = Mid$(Data, posTime, posFrom - posTime - 1)
      strFrom = Mid$(Data, posFrom, posMessage - posFrom - 1)
      strMessage = Mid$(Data, posMessage + 1, endMessage - posMessage - 2)

      strMessage = Replace(strMessage, "\n", "<br>")
      strMessage = Replace(strMessage, vbCrLf, "<br>")
      strMessage = Replace(strMessage, "  ", "&nbsp;&nbsp;")

      cntMessage = cntMessage + 1

      'add entry to textbox'
      If strDate <> oldDate Then
         oldDate = strDate
         If I < lenText Then strDate = vbCrLf & strDate
         'every day a new date'
         HTMLCode = "<br><font class=" & Chr$(34) & "NoIndent" & Chr$(34) & " color=" & Chr$(34) & GetHTMLColor(colDate) & Chr$(34) & "><b>" & strDate & "</b></font><br>"
         Print #filNo, HTMLCode
      End If
         
      HTMLCode = ""
      
      'time and name'
      If strFrom = "Local" Then
         HTMLCode = HTMLCode & "<font color=" & Chr$(34) & GetHTMLColor(colOwnUsername) & Chr$(34) & "><b>"
         If modClient.LocalUser.cpUsername <> "" Then
            HTMLCode = HTMLCode & strTime & ", " & modClient.LocalUser.cpUsername & ": "
         Else
            HTMLCode = HTMLCode & strTime & ", " & "Benutzer" & ": "
         End If
         HTMLCode = HTMLCode & "</b></font>"
      ElseIf strFrom = "System" Then
         HTMLCode = HTMLCode & "<font color=" & Chr$(34) & GetHTMLColor(colSystemMessage) & Chr$(34) & "><b>" & strTime & ": " & strMessage & "</b></font><br>"
      Else
         HTMLCode = HTMLCode & "<font color=" & Chr$(34) & GetHTMLColor(colUsername) & Chr$(34) & "><b>" & strTime & ", " & strFrom & ": " & "</b></font>"
      End If
      
      Print #filNo, HTMLCode
      
      If strFrom <> "System" Then
         'message'
         HTMLCode = "<font class=" & Chr$(34) & "NoIndent" & Chr$(34) & " color=" & Chr$(34) & GetHTMLColor(colChatMessage) & Chr$(34) & ">" & strMessage & "</font><br>"
         Print #filNo, HTMLCode
      End If
         
      I = posDate

   Next I
     
   'close destination file'
   HTMLCode = "</body></html>"
   Print #filNo, HTMLCode
   Close #filNo

End Sub

Private Function GetHTMLColor(iColor As Long) As String
   Dim r As Long, G As Long, B As Long
   B = (iColor And 16711680) / 65536
   G = (iColor And 65280) / 256
   r = iColor And 255
   GetHTMLColor = "#" & Format$(Hex$(r), "&&") & Format$(Hex$(G), "&&") & Format$(Hex$(B), "&&")
End Function
