VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CEncoding"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Function GetCommandLine( _
  Statement As String, _
  ParamArray Parameters() _
) As String
    GetCommandLine = Statement
    
    If UBound(Parameters) > -1 Then
        Dim i As Long
        
        For i = 0 To UBound(Parameters)
            If CStr(Parameters(i)) = "" Then Parameters(i) = "\0"
            GetCommandLine = GetCommandLine & "|" & EncodeParameter(CStr(Parameters(i)))
        Next i
    End If
End Function

Public Function CodeCommandLine(CommandLine As String, strRemoteIP As String, strChatNick As String) As String
    Dim Key As String
    Key = Keys.FindKey(strRemoteIP, strChatNick)
    If Not Key = "" Then
        Dim src()   As Byte
        Dim tgt()   As Byte
        Call String_to_byteArray(CommandLine, src())
        Call CryptoInstance.Crypt(src(), tgt(), Key, False)
        CodeCommandLine = CRYPTO_HEADER & byteArray_to_string(tgt())
    Else
        CodeCommandLine = CommandLine
    End If
End Function
'----------------------------------------------------

Private Function EncodeParameter(Value As String) As String
    EncodeParameter = Replace(Value, "\", "\\")
    EncodeParameter = Replace(EncodeParameter, vbCr, "\n")
    EncodeParameter = Replace(EncodeParameter, "|", "\|")
    EncodeParameter = Replace(EncodeParameter, vbNullChar, "\0")
End Function

Public Function URLEncode(Url As String) As String
   URLEncode = Replace(Url, " ", "%20")
End Function

Public Function DecodeNickName(NickName As String) As String
   DecodeNickName = Replace(NickName, "%20", " ")
End Function

