VERSION 5.00
Begin VB.Form NotifyDialog 
   BorderStyle     =   0  'Kein
   ClientHeight    =   975
   ClientLeft      =   9675
   ClientTop       =   6840
   ClientWidth     =   2595
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   65
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   173
   ShowInTaskbar   =   0   'False
   Begin projIM.CloseButton LblExit 
      Height          =   240
      Left            =   2310
      TabIndex        =   0
      Top             =   45
      Width           =   240
      _ExtentX        =   423
      _ExtentY        =   423
   End
   Begin VB.Timer EffectTimer 
      Left            =   840
      Top             =   300
   End
   Begin VB.Timer TimeoutTimer 
      Left            =   1380
      Top             =   300
   End
   Begin VB.Image imgInfo 
      Height          =   465
      Left            =   120
      Picture         =   "DlgNotify.frx":0000
      Top             =   360
      Width           =   420
   End
End
Attribute VB_Name = "NotifyDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type RECT
    Left    As Long
    Top     As Long
    Right   As Long
    Bottom  As Long
End Type

Private Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" ( _
  ByVal hwnd As Long, _
  ByVal nIndex As Long _
) As Long
Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" ( _
  ByVal hwnd As Long, _
  ByVal nIndex As Long, _
  ByVal dwNewLong As Long _
) As Long
Private Declare Function SetLayeredWindowAttributes Lib "user32.dll" ( _
  ByVal hwnd As Long, _
  ByVal crKey As Long, _
  ByVal bAlpha As Byte, _
  ByVal dwFlags As Long _
) As Long
Private Declare Function SystemParametersInfo Lib "user32.dll" Alias "SystemParametersInfoA" ( _
  ByVal uAction As Long, _
  ByVal uParam As Long, _
  ByRef lpvParam As Any, _
  ByVal fuWinIni As Long _
) As Long

Private Const GWL_EXSTYLE As Long = (-20)
Private Const WS_EX_LAYERED As Long = &H80000
Private Const SWP_NOACTIVATE As Long = &H10

Private Const SPI_GETWORKAREA As Long = 48

Private Const LWA_ALPHA As Long = &H2

Private Enum EffectDirection
    ShowUp
    ExitOut
End Enum
'----------------------------------------------------

Private m_Effect As NotifyEffects
Private m_Dir As EffectDirection
Private m_EffectDuration As Long
Private m_MaxState As Long
Private m_ScreenClient As RECT
Private m_MaxHeight As Long
Private m_ClipBounds As RECT
Private m_IsMouseDown As Boolean
Private m_UserName As String
'----------------------------------------------------

Public Sub Create( _
  Caption As String, _
  Text As String, _
  Optional User As String = vbNullString, _
  Optional Width As Long = 175, _
  Optional Height As Long = 65, _
  Optional Effect As NotifyEffects = NoEffect, _
  Optional TimeOut As Long = 6000 _
)
    Call SystemParametersInfo(SPI_GETWORKAREA, 0&, m_ScreenClient, 0&)
    
    If DialogBottom <> 0 Then
        m_ScreenClient.Bottom = DialogBottom
        DialogBottom = DialogBottom - Height
    Else
        DialogBottom = m_ScreenClient.Bottom - Height
    End If
    
    InstanceCount = InstanceCount + 1
    
    Me.Height = Height * Screen.TwipsPerPixelY
    Me.Width = Width * Screen.TwipsPerPixelX
    
    Me.Left = m_ScreenClient.Right * Screen.TwipsPerPixelX - Me.Width
    Me.Top = m_ScreenClient.Bottom * Screen.TwipsPerPixelY - Me.Height
    
    m_UserName = User
    Call PaintForm(Caption, Text, User)
    
    Select Case Effect
        Case NoEffect
            EffectTimer.Interval = 0
            m_EffectDuration = 0
        Case FadeInOut
            EffectTimer.Interval = 50
            Call SetTransparency(0)
            m_EffectDuration = 600
        Case ScrollUpDown
            EffectTimer.Interval = 20
            Me.Top = m_ScreenClient.Bottom * Screen.TwipsPerPixelY
            m_MaxHeight = Me.Height
            Me.Height = 0
            m_EffectDuration = 700
    End Select
    
    m_MaxState = m_EffectDuration \ 20
    
    m_Effect = Effect
    m_Dir = ShowUp
    
    If TimeOut - m_EffectDuration > 0 Then
        TimeoutTimer.Interval = TimeOut - m_EffectDuration
        TimeoutTimer.Enabled = True
    End If
    
    ' Last action. '
    
    EffectTimer.Enabled = Effect <> NoEffect
    
    On Error Resume Next
    ' Fix for: err 401: ein ungebundenes Formular kann nicht angezeigt werden, '
    ' whrend modales Formular angezeigt wird. '
    'Call Me.Show
    'Bugfix Focusbug
    'Window TOPMOST setzen, inaktiviert!
    Call SetWindowPos(Me.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOSIZE Or SWP_NOMOVE Or SWP_HIDEWINDOW)
    'Window anzeigen inaktiviert!
    Call ShowWindow(Me.hwnd, SW_SHOWNOACTIVATE)
End Sub

Private Sub PaintForm(Caption As String, Text As String, Optional User As String = vbNullString)
    Me.AutoRedraw = True
    Me.BackColor = vbInfoBackground
    Me.ForeColor = vbInfoText
    
    ' Draw Border. '
    
    Me.Line (0, Me.ScaleHeight - 1)-(0, 0), vb3DLight
    Me.Line (0, 0)-(Me.ScaleWidth - 1, 0), vb3DLight
    Me.Line (Me.ScaleWidth - 1, 0)-(Me.ScaleWidth - 1, Me.ScaleHeight - 1), vb3DDKShadow
    Me.Line (Me.ScaleWidth - 1, Me.ScaleHeight - 1)-(0, Me.ScaleHeight - 1), vb3DDKShadow
    
    Me.Line (1, Me.ScaleHeight - 2)-(1, 1), vb3DHighlight
    Me.Line (1, 1)-(Me.ScaleWidth - 2, 1), vb3DHighlight
    Me.Line (Me.ScaleWidth - 2, 1)-(Me.ScaleWidth - 2, Me.ScaleHeight - 2), vb3DShadow
    Me.Line (Me.ScaleWidth - 2, Me.ScaleHeight - 2)-(1, Me.ScaleHeight - 2), vb3DShadow

    Me.Line (2, Me.ScaleHeight - 3)-(2, 2), vb3DShadow
    Me.Line (2, 2)-(Me.ScaleWidth - 2, 2), vb3DShadow
    Me.Line (Me.ScaleWidth - 3, 3)-(Me.ScaleWidth - 3, Me.ScaleHeight - 3), vb3DHighlight
    Me.Line (Me.ScaleWidth - 3, Me.ScaleHeight - 3)-(2, Me.ScaleHeight - 3), vb3DHighlight
    
    ' Set text clip bounds. '
    
    m_ClipBounds.Left = 7
    m_ClipBounds.Top = 5
    m_ClipBounds.Right = Me.ScaleWidth - m_ClipBounds.Left
    m_ClipBounds.Bottom = Me.ScaleHeight - m_ClipBounds.Top
    
    ' Draw caption. '
    
    Me.CurrentX = 7
    Me.CurrentY = 5
    Me.Font.Bold = True
    Call PrintText(Caption)
    
    ' Draw message. '
    
    m_ClipBounds.Left = m_ClipBounds.Left + imgInfo.Left + imgInfo.Width
    m_ClipBounds.Top = imgInfo.Top
    Me.CurrentX = 0
    
    If User <> vbNullString Then
        Call PrintText(User)
    End If
    
    Me.Font.Bold = False
    Call PrintText(Text)
    
    LblExit.Top = 4
    LblExit.Left = Me.ScaleWidth - LblExit.Width - 3
    
    Call SetTransparency(180)
End Sub

Private Sub EffectTimer_Timer()
    Static State As Long
    
    Select Case m_Dir
        Case ShowUp
            State = State + 1
        Case ExitOut
            State = State - 1
    End Select
    
    If State = m_MaxState + 1 Then
        EffectTimer.Enabled = False
        
        ' Ensure effect terminates. '
        
        If m_Effect = FadeInOut Then _
            Call SetTransparency(255)
        Exit Sub
    ElseIf State = 0 Then
        Call Unload(Me)
        Exit Sub
    End If
    
    Select Case m_Effect
        Case NoEffect
        Case FadeInOut
            Call SetTransparency(State * 255 / m_MaxState)
        Case ScrollUpDown
            Me.Height = State * m_MaxHeight / m_MaxState
            Me.Top = m_ScreenClient.Bottom * Screen.TwipsPerPixelY - Me.Height
    End Select
End Sub

Private Sub Form_Activate()
Call SetWindowLong(Me.hwnd, GWL_HWNDPARENT, 0)
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
Debug.Print KeyCode
End Sub

'----------------------------------------------------
Private Sub TimeoutTimer_Timer()
    If m_Effect = NoEffect Then
        Call Unload(Me)
        Exit Sub
    End If
    
    m_Dir = ExitOut
    EffectTimer.Enabled = True
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbLeftButton Then _
        If X >= m_ClipBounds.Left And X <= m_ClipBounds.Right Then _
            If Y >= m_ClipBounds.Top And Y <= m_ClipBounds.Bottom Then _
                m_IsMouseDown = True
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbLeftButton And m_IsMouseDown Then
        If X >= m_ClipBounds.Left And X <= m_ClipBounds.Right Then
            If Y >= m_ClipBounds.Top And Y <= m_ClipBounds.Bottom Then
                m_IsMouseDown = False
                Call Unload(Me)
                Call dlgMain.CreateConnection.ConnectClient( _
                    m_UserName, _
                    dlgMain.ClientManagement.GetClientRemoteIP(m_UserName), _
                    dlgMain.ClientManagement.GetClientLAN_IP(m_UserName) _
                )
            End If
        End If
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    InstanceCount = InstanceCount - 1
    
    If InstanceCount = 0 Then
        DialogBottom = 0
    End If
End Sub

Private Sub LblExit_Click()
    Call Unload(Me)
End Sub

Private Sub SetTransparency(Value As Byte)
    If Value = 255 Then
        ' Restore opacity. '
        
        Call SetWindowLong( _
            Me.hwnd, _
            GWL_EXSTYLE, _
            GetWindowLong(Me.hwnd, GWL_EXSTYLE) Xor WS_EX_LAYERED _
        )
    Else
        Call SetWindowLong( _
            Me.hwnd, _
            GWL_EXSTYLE, _
            GetWindowLong(Me.hwnd, GWL_EXSTYLE) Or WS_EX_LAYERED _
        )
        Call SetLayeredWindowAttributes(Me.hwnd, 0&, Value, LWA_ALPHA)
    End If
End Sub

Private Sub PrintText(Text As String)
    Dim I As Long
    Dim Words() As String
    
    If Me.CurrentY < m_ClipBounds.Top Then
        Me.CurrentY = m_ClipBounds.Top
    End If
    
    If Me.CurrentX < m_ClipBounds.Left Then
        Me.CurrentX = m_ClipBounds.Left
    End If
    
    Words = Split(Text, " ")
    
    For I = 0 To UBound(Words)
        If Me.CurrentX + Me.TextWidth(Words(I)) > m_ClipBounds.Right Then
            Me.CurrentX = m_ClipBounds.Left
            Me.CurrentY = Me.CurrentY + Me.TextHeight(Words(I))
        End If
        
        Me.Print Words(I) & " ";
    Next I
End Sub
